!------------------------------------------------------------
subroutine zera_01(num_lyapu,system_dim,num_neurons,ini2)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,system_dim,num_neurons
real(kind=8),intent(out)	:: ini2(num_neurons*system_dim,num_lyapu)
integer(kind=4)			:: j,k

ini2=0.d0
do j=1,num_neurons*system_dim
	do k=1,num_lyapu
		if (k==j) ini2(j,k)=1.d0
	enddo
enddo

return
end subroutine zera_01

!------------------------------------------------------------

subroutine gera_ci(matriz_x,system_dim,num_neurons,mult_ci)
implicit none
integer(kind=4),intent(in)	:: system_dim,num_neurons
real(kind=8),intent(inout)	:: matriz_x(system_dim,num_neurons)
real(kind=8),intent(in)		:: mult_ci
real(kind=8)			:: tmpran2
integer(kind=4)			:: i

do i=1,num_neurons
	call random_number(tmpran2) !create a random sequence
 	matriz_x(1,i)=-1.30784489d0+tmpran2*mult_ci !for p
 	call random_number(tmpran2) !create a random sequence
 	matriz_x(2,i)=-7.32183132d0+tmpran2*mult_ci !for q
 	call random_number(tmpran2) !create a random sequence
 	matriz_x(3,i)=3.35299859d0+tmpran2*mult_ci !for n
enddo

matriz_x(4,:)=0.d0 !for phase

return
end subroutine gera_ci

!-----------------------------------------------------------

subroutine gera_para_dedo_09(num_neurons,escolhe_geometria,matriz_acopla_electrical,matriz_acopla_chemical,char_param_chem_coupling,char_param_elec_coupling,char_counter_realization)
implicit none
integer(kind=4),intent(in)	:: num_neurons,escolhe_geometria
integer(kind=4),intent(inout)	:: matriz_acopla_electrical(num_neurons,num_neurons),matriz_acopla_chemical(num_neurons,num_neurons)
character(*),intent(in)		:: char_param_chem_coupling,char_param_elec_coupling,char_counter_realization
integer(kind=4)			:: i,j

select case (escolhe_geometria)
	case (1)
		!--------- read from a file the adjacency matrix of the electrical connections ---------
		open(12,file='../../adjm_c-elegans_graph_ec_commun.in',status='old')
		read(12,*) ((matriz_acopla_electrical(i,j),i=1,num_neurons),j=1,num_neurons)
		close(12)

		!--------- read from a file the adjacency matrix of the chemical connections ---------
		open(12,file='../../adjm_c-elegans_graph_cc_inter_commun.in',status='old')
		read(12,*) ((matriz_acopla_chemical(i,j),i=1,num_neurons),j=1,num_neurons)
		close(12)
	case default
		write(*,'(///," NON-EXISTENENT TOPOLOGY chosen by the user!")')
		write(*,'(/," Topology index should be between ",i5," and ",i5)') 1,5
		write(*,'(" This can not be!")')
		write(*,'(" Program will abort now!!!",///)')
		stop
end select

return
end subroutine gera_para_dedo_09

!------------------------------------------------------------

subroutine write_used_time(time_begin)
implicit none
real(kind=4),intent(in)		:: time_begin
real(kind=4)			:: time_end

call cpu_time(time_end)
write(1,*)
write(1,'(/,1x,"Time of operation was",1x,f13.3,1x,"seconds")') time_end-time_begin
write(1,*)
write(1,'(1x,"Programmed by Chris Antonopoulos")')
call flush(1)

write(*,'(/,1x,"Time of operation was",1x,f13.3,1x,"seconds")') time_end-time_begin
write(*,*)
write(*,'(1x,"Programmed by Chris Antonopoulos")')

return
end subroutine write_used_time

!------------------------------------------------------------

subroutine write_in_file(RK_method_index_traj,RK_method_index_LEs,write_traj_file_switch,write_LEs_file_switch,matriz_par,num_neurons,dim_par,num_lyapu,dt,trans_traj,tam_traj,escolhe_geometria,t0,OP,mult_ci,n_step,lyapu_on,param_chem_coupling,param_elec_coupling,seed_ci_initial,I_ext_switch,I_ext,I_ext_amplitude,num_communities)
implicit none
integer(kind=4),intent(in)	:: RK_method_index_traj,RK_method_index_LEs,trans_traj,write_traj_file_switch,write_LEs_file_switch,num_neurons,dim_par,num_lyapu,tam_traj,n_step,lyapu_on,escolhe_geometria,seed_ci_initial,I_ext_switch,num_communities
real(kind=8),intent(in)		:: dt,t0,OP,mult_ci,param_chem_coupling,param_elec_coupling,matriz_par(dim_par,num_neurons),I_ext,I_ext_amplitude

write(1,'(/," *********************************************************************")')
write(1,'(" Hindmarsh-Rose neural clustered network evolution simulation (serial)")')
write(1,'(" *********************************************************************",/)')
write(*,'(/," *********************************************************************")')
write(*,'(" Hindmarsh-Rose neural clustered network evolution simulation (serial)")')
write(*,'(" *********************************************************************",/)')
if (RK_method_index_traj==1) then
	write(1,'(/," Choice of Runge - Kutta method (TRAJECTORY): 1-stage Euler method (1st order) ---> OPTION 1")')
	write(*,'(/," Choice of Runge - Kutta method (TRAJECTORY): 1-stage Euler method (1st order) ---> OPTION 1")')
endif
if (RK_method_index_traj==2) then
	write(1,'(/," Choice of Runge - Kutta method (TRAJECTORY): 2-stage Heun method (or improved Euler method) ---> OPTION 2")')
	write(*,'(/," Choice of Runge - Kutta method (TRAJECTORY): 2-stage Heun method (or improved Euler method) ---> OPTION 2")')
endif
if (RK_method_index_traj==3) then
	write(1,'(/," Choice of Runge - Kutta method (TRAJECTORY): 2-stage Arithmetic Mean Runge - Kutta method) (3rd order) ---> OPTION 3")')
	write(*,'(/," Choice of Runge - Kutta method (TRAJECTORY): 2-stage Arithmetic Mean Runge - Kutta method) (3rd order) ---> OPTION 3")')
endif
if (RK_method_index_traj==4) then
	write(1,'(/," Choice of Runge - Kutta method (TRAJECTORY): Classic Runge - Kutta method (4th order) ---> OPTION 4")')
	write(*,'(/," Choice of Runge - Kutta method (TRAJECTORY): Classic Runge - Kutta method (4th order) ---> OPTION 4")')
endif
	
if (num_lyapu>=1) then
	if (RK_method_index_LEs==1) then
		write(1,'(/," Choice of Runge - Kutta method (LEs): 1-stage Euler method (1st order) ---> OPTION 1")')
		write(*,'(/," Choice of Runge - Kutta method (LEs): 1-stage Euler method (1st order) ---> OPTION 1")')
	endif
	if (RK_method_index_LEs==2) then
		write(1,'(/," Choice of Runge - Kutta method (LEs): 2-stage Heun method (or improved Euler method) ---> OPTION 2")')
		write(*,'(/," Choice of Runge - Kutta method (LEs): 2-stage Heun method (or improved Euler method) ---> OPTION 2")')
	endif
	if (RK_method_index_LEs==3) then
		write(1,'(/," Choice of Runge - Kutta method (LEs): 2-stage Arithmetic Mean Runge - Kutta method (3rd order) ---> OPTION 3")')
		write(*,'(/," Choice of Runge - Kutta method (LEs): 2-stage Arithmetic Mean Runge - Kutta method (3rd order) ---> OPTION 3")')
	endif
	if (RK_method_index_LEs==4) then
		write(1,'(/," Choice of Runge - Kutta method (LEs): Classic Runge - Kutta method (4th order) ---> OPTION 4")')
		write(*,'(/," Choice of Runge - Kutta method (LEs): Classic Runge - Kutta method (4th order) ---> OPTION 4")')
	endif
endif

write(1,'(/," Number of neurons= ",i6)') num_neurons
write(*,'(/," Number of neurons= ",i6)') num_neurons

write(1,'(/," Number of communities= ",i6)') num_communities
write(*,'(/," Number of communities= ",i6)') num_communities

if (num_lyapu>=1) then
	write(1,'(/," Number of Lyapunov exponents= ",i6)') num_lyapu
	write(*,'(/," Number of Lyapunov exponents= ",i6)') num_lyapu
else
	write(1,'(/," No Lyapunov exponents will be computed!",/)')
	write(*,'(/," No Lyapunov exponents will be computed!",/)')
endif
if (write_traj_file_switch/=0) then
	write(1,'(" The trajectory is written in the files")')
	write(*,'(" The trajectory is written in the files")')
else
	write(1,'(" The trajectory is NOT written in the files")')
	write(*,'(" The trajectory is NOT written in the files")')
endif
if (num_lyapu>=1) then
	if (write_LEs_file_switch/=0) then
		write(1,'(" The Lyapunov exponents are written in the file",/)')
		write(*,'(" The Lyapunov exponents are written in the file",/)')
	else
		write(1,'(" The Lyapunov exponents are NOT written in the file",/)')
		write(*,'(" The Lyapunov exponents are NOT written in the file",/)')
	endif
endif
write(1,'(" Integration step of the Runge - Kutta integrator= ",f15.7)') dt
write(*,'(" Integration step of the Runge - Kutta integrator= ",f15.7)') dt
write(1,'(" Initial integration time=",f15.7)') t0
write(*,'(" Initial integration time=",f15.7)') t0
write(1,'(" Transient time up to=",f15.7)') trans_traj*dt
write(*,'(" Transient time up to=",f15.7)') trans_traj*dt
write(1,'(" Final integration time=",f15.7)') real(tam_traj*dt,8)
write(*,'(" Final integration time=",f15.7)') real(tam_traj*dt,8)
write(1,'(" tam_traj=",i16)') tam_traj
write(*,'(" tam_traj=",i16)') tam_traj
write(1,'(" Initial seed for the random number generator=",i16)') seed_ci_initial
write(*,'(" Initial seed for the random number generator=",i16)') seed_ci_initial

write(1,'(/," OP=",f15.7)') OP
write(*,'(/," OP=",f15.7)') OP
write(1,'(/," Amplitude variation on the initial conditions of the neurons=",es12.5)') mult_ci
write(*,'(/," Amplitude variation on the initial conditions of the neurons=",es12.5)') mult_ci
if (num_lyapu>=1) then
	write(1,'(" The Gram-Schmidt process for Lyapunov exponents is performed at multiples of ",i6," time steps")') n_step
	write(*,'(" The Gram-Schmidt process for Lyapunov exponents is performed at multiples of ",i6," time steps")') n_step
	write(1,'(" The Gram-Schmidt process for Lyapunov exponents is performed at multiples of ",es12.5," time")') n_step*dt
	write(*,'(" The Gram-Schmidt process for Lyapunov exponents is performed at multiples of ",es12.5," time")') n_step*dt
	write(1,'(" lyapu_on=",i6)') lyapu_on
	write(*,'(" lyapu_on=",i6)') lyapu_on
endif
if (matriz_par(2,1)==2.d0) write(1,'(/," The NETWORK is EXCITATORY")')
if (matriz_par(2,1)==2.d0) write(*,'(/," The NETWORK is EXCITATORY")')
if (matriz_par(2,1)==-2.d0) write(1,'(/," The NETWORK is INHIBITORY")')
if (matriz_par(2,1)==-2.d0) write(*,'(/," The NETWORK is INHIBITORY")')
if (I_ext_switch==0) then
	write(1,'(/," I_ext= ",f15.7,/)') I_ext
	write(*,'(/," I_ext= ",f15.7,/)') I_ext
else
	write(1,'(/," I_ext changes in time in a sinusoidal way between [",es12.5,",",es12.5,"] time interval. Percentage of amplitude change: ",f7.3,"%",/)') trans_traj*dt,tam_traj*dt,I_ext_amplitude*100.d0
	write(*,'(/," I_ext changes in time in a sinusoidal way between [",es12.5,",",es12.5,"] time interval. Percentage of amplitude change: ",f7.3,"%",/)') trans_traj*dt,tam_traj*dt,I_ext_amplitude*100.d0
endif
write(1,'(" V_syn= ",f15.7,/)') matriz_par(2,1)
write(*,'(" V_syn= ",f15.7,/)') matriz_par(2,1)
write(1,'(" Theta_syn= ",f15.7)') matriz_par(6,1)
write(*,'(" Theta_syn= ",f15.7)') matriz_par(6,1)
write(1,'(/," Chemical coupling= ",f26.16)') param_chem_coupling
write(*,'(/," Chemical coupling= ",f26.16)') param_chem_coupling
write(1,'(" Electrical coupling= ",f26.16)') param_elec_coupling
write(*,'(" Electrical coupling= ",f26.16)') param_elec_coupling
call flush(1)

return
end subroutine write_in_file

!------------------------------------------------------------

subroutine open_various_files(num_lyapu,write_traj_file_switch,write_LEs_file_switch,syncmatrixglobalnetwork_switch,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,write_traj_file_switch,write_LEs_file_switch,syncmatrixglobalnetwork_switch
character(*),intent(in)		:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

if (write_traj_file_switch/=0) then
	open(2,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'trajetoria_p_nnev12n'//char_num_neurons//'.dat',status='replace')
!	open(3,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'trajetoria_q_nnev12n'//char_num_neurons//'.dat',status='replace')
!	open(4,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'trajetoria_n_nnev12n'//char_num_neurons//'.dat',status='replace')
!	open(5,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'trajetoria_phase_nnev12n'//char_num_neurons//'.dat',status='replace')
endif
open(20,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'S_global_S_clusters_phase_synchronization_vs_time_nnev12n'//char_num_neurons//'.dat',status='replace')
if (syncmatrixglobalnetwork_switch==1) open(22,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'S_global_synchronization_matrix_final_time_nnev12n'//char_num_neurons//'.dat',status='replace')
open(17,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'I_ext_vs_time_nnev12n'//char_num_neurons//'.dat',status='replace')
if (num_lyapu>=1.and.write_LEs_file_switch/=0) open(6,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'LEs_nnev12n'//char_num_neurons//'.dat',status='replace')

return
end subroutine open_various_files

!------------------------------------------------------------

subroutine close_various_files(num_lyapu,write_traj_file_switch,write_LEs_file_switch,syncmatrixglobalnetwork_switch)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,write_traj_file_switch,write_LEs_file_switch,syncmatrixglobalnetwork_switch

if (write_traj_file_switch/=0) then
	close(2)
!	close(3)
!	close(4)
!	close(5)
endif
close(17)
if (num_lyapu>=1.and.write_LEs_file_switch/=0) close(6)
close(20)
if (syncmatrixglobalnetwork_switch==1) close(22)

return
end subroutine close_various_files

!------------------------------------------------------------

subroutine initialize_matrices(num_lyapu,system_dim,num_neurons,dim_par,lamb_lyap,lamb_ordena,lamb_positivos,ini2,matriz_par,matriz_x,guarda_x,matriz_cont)
implicit none
integer(kind=4),intent(in)	:: num_lyapu,system_dim,num_neurons,dim_par
integer(kind=4),intent(inout)	:: matriz_cont(num_neurons)
real(kind=8),intent(inout)	:: lamb_lyap(num_lyapu),lamb_ordena(num_lyapu),lamb_positivos(num_lyapu),ini2(system_dim*num_neurons,num_lyapu),matriz_par(dim_par,num_neurons),matriz_x(system_dim,num_neurons),guarda_x(num_neurons)

!initialization of matrices
if (num_lyapu>=1) then
	lamb_lyap=0.d0
	lamb_ordena=0.d0
	lamb_positivos=0.d0
endif
if (num_lyapu>=1) ini2=0.d0
matriz_par=0.d0
matriz_x=0.d0
guarda_x=0.d0
matriz_cont=0

return
end subroutine initialize_matrices

!------------------------------------------------------------

subroutine create_plot_gnu_file(char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

open(11,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_nnev12n'//char_num_neurons//'.gnu',status='replace')
write(11,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/Ic_maximization_nnev12n",a,".eps''")')  char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(11,'("set term postscript eps color enhanced")')
write(11,'("set size 0.6,0.6")')

write(11,'("#set format x ""10^{%L}""")')
write(11,'("#set format y ""10^{%L}""")')

write(11,'("set xtics 1")')

write(11,'("unset logscale xy")')
write(11,'("set title ''nnev12n",a,"''")') char_num_neurons
write(11,'("set xlabel ''Number of MIR maximizing interconnections''")')
write(11,'("#set ylabel ''{/Symbol l}_1 - {/Symbol l}_2''")')

write(11,'("#unset key")')
write(11,'("#set label 1 ''c)'' at 6e7,0.05 center")')

write(11,'("plot [0:][0:] ''cc=",a,"_ec=",a,"/Ic_maximization_nnev12n",a,".dat'' u 5 w lp title ""{/Symbol l}_1 - {/Symbol l}_2""")') char_param_chem_coupling,char_param_elec_coupling,char_num_neurons

write(11,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/counter_non_maximizing_interconnections_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(11,'("set term postscript eps color enhanced")')
write(11,'("set size 0.6,0.6")')

write(11,'("#set format x ""10^{%L}""")')
write(11,'("#set format y ""10^{%L}""")')

write(11,'("set xtics 1")')

write(11,'("unset key")')
write(11,'("unset logscale xy")')
write(11,'("set title ''nnev12n",a,"''")') char_num_neurons
write(11,'("unset xlabel")')
write(11,'("unset ylabel")')
write(11,'("set xlabel ''Number of MIR maximizing interconnections''")')
write(11,'("set ylabel ''Number of MIR non-maximizing I_c''")')

write(11,'("#unset key")')
write(11,'("#set label 1 ''c)'' at 6e7,0.05 center")')

write(11,'("plot [0:][0:] ''cc=",a,"_ec=",a,"/counter_non_maximizing_interconnections_nnev12n",a,".dat'' u 1:2 w lp")') char_param_chem_coupling,char_param_elec_coupling,char_num_neurons

close(11)

return
end subroutine create_plot_gnu_file

!------------------------------------------------------------

subroutine create_I_ext_vs_time_plot_gnu_file(tam_traj,dt,I_ext,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
integer(kind=4),intent(in)	:: tam_traj
real(kind=8),intent(in)		:: dt,I_ext
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

open(18,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_I_ext_vs_time_nnev12n'//char_num_neurons//'.gnu',status='replace')

write(18,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/I_ext_vs_time_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(18,'("set term postscript eps color enhanced")')
write(18,'("set size 0.6,0.6")')

write(18,'("set xtics ",i10)') int(tam_traj*dt/5)
write(18,'("set key at screen 0.446,screen 0.21 center")')

write(18,'("set title ''I_{ext} vs time''")')
write(18,'("set xlabel ''t''")')
write(18,'("#set ylabel ''I_{ext}''")')

write(18,'("#unset key")')
write(18,'("#set label 1 ''c)'' at 6e7,0.05 center")')

write(18,'("plot [0:",es12.5,"][0:] ''cc=",a,"_ec=",a,"/",a,"rn/I_ext_vs_time_nnev12n",a,".dat'' u 1:2 w l title ""I_{ext}"",",f26.16," w l title """,f10.3,"""")') tam_traj*dt,char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons,I_ext,I_ext

close(18)

return
end subroutine create_I_ext_vs_time_plot_gnu_file

!------------------------------------------------------------

subroutine create_S_global_S_clusters_vs_time_plot_gnu_file(char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization,num_communities)
implicit none
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization
integer(kind=4),intent(in)	:: num_communities
integer(kind=4)			:: i

open(18,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_S_global_S_clusters_vs_time_nnev12n'//char_num_neurons//'.gnu',status='replace')

write(18,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/S_global_S_clusters_vs_time_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(18,'("set term postscript eps color enhanced")')

write(18,'("set size 0.6,0.6")')

write(18,'("#set format x ""10^{%L}""")')
write(18,'("#set format y ""10^{%L}""")')

write(18,'("#set xtics 1")')

write(18,'("set key font "",6""")')

write(18,'("unset logscale xy")')
write(18,'("#set title ''Global network vs clusters synchronization''")')
write(18,'("set xlabel ''t''")')
write(18,'("#set ylabel ''''")')

write(18,'("#unset key")')
write(18,'("#set label 1 ''c)'' at 6e7,0.05 center")')

write(18,'("set key left bottom")')

write(18,'("plot [0:][0:1.1] ''cc=",a,"_ec=",a,"/",a,"rn/S_global_S_clusters_phase_synchronization_vs_time_nnev12n",a,".dat'' u 1:2 w l title ""S_g""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

do i=1,num_communities
	write(18,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/S_global_S_clusters_phase_synchronization_vs_time_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
	write(18,'("set term postscript eps color enhanced")')
	write(18,'("replot ''cc=",a,"_ec=",a,"/",a,"rn/S_global_S_clusters_phase_synchronization_vs_time_nnev12n",a,".dat'' u 1:",i5," w l title ""C_{",i5,"}""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons,i+2,i
enddo

close(18)

return
end subroutine create_S_global_S_clusters_vs_time_plot_gnu_file

!------------------------------------------------------------

subroutine create_S_global_synchronization_matrix_final_time_plot_gnu_file(num_neurons,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
integer(kind=4),intent(in)	:: num_neurons
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

open(18,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_S_global_synchronization_matrix_final_time_nnev12n'//char_num_neurons//'.gnu',status='replace')
write(18,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/S_global_synchronization_matrix_final_time_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(18,'("set term postscript eps color enhanced")')
write(18,'("set size 0.6,0.6")')

write(18,'("#set pm3d map interpolate 0,0")')

write(18,'("set size square")')
write(18,'("unset key")')

write(18,'("set border linewidth 0")')

write(18,'("set title ''Synchronization matrix (functional connections)'' font "",9""")')

write(18,'("rows = ""`awk ''END {print NR}'' < ''cc=",a,"_ec=",a,"/",a,"rn/S_global_synchronization_matrix_final_time_nnev12n",a,".dat''`""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(18,'("columns = ""`awk ''{if(NR == 1) print NF}'' < ''cc=",a,"_ec=",a,"/",a,"rn/S_global_synchronization_matrix_final_time_nnev12n",a,".dat''`""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(18,'("set xtics (""1"" 0, gprintf(""%3.0f"",columns) columns-1)")')
write(18,'("set xtics add 0,columns/5,columns")')

write(18,'("set ytics (""1"" 0, gprintf(""%3.0f"",rows) rows-1)")')
write(18,'("set ytics add 0,rows/5,rows")')

write(18,'("#set xlabel ''Neuron''")')
write(18,'("#set ylabel ''Neuron'' rotate by 0 left")')

write(18,'("set cbtics 0.2")')
write(18,'("set cbrange [0:1]")')

write(18,'("#splot [0:",i5,"][",i5,":0] ''cc=",a,"_ec=",a,"/S_global_synchronization_matrix_final_time_nnev12n",a,".dat'' matrix")') num_neurons-1,num_neurons-1,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons
write(18,'("plot [-0.5:",f26.16,"][",f26.16,":-0.5] ''cc=",a,"_ec=",a,"/",a,"rn/S_global_synchronization_matrix_final_time_nnev12n",a,".dat'' matrix with image")') real(num_neurons-0.5,8),real(num_neurons-0.5,8),char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

close(18)

return
end subroutine create_S_global_synchronization_matrix_final_time_plot_gnu_file

!------------------------------------------------------------

subroutine create_plot_rlink_glob_synch_average_C_matr_gnu_file(char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

open(11,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_rlink_glob_synch_average_C_matr_nnev12n'//char_num_neurons//'.gnu',status='replace')
write(11,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/rlink_glob_synch_average_C_matr_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(11,'("set term postscript eps color enhanced")')
write(11,'("set size 0.6,0.6")')

write(11,'("#set format x ""10^{%L}""")')
write(11,'("#set format y ""10^{%L}""")')

write(11,'("set xtics 1")')

write(11,'("unset logscale xy")')
write(11,'("set xlabel ''Number of MIR maximizing interconnections''")')
write(11,'("#set ylabel ''r_{link}''")')

write(11,'("#unset key")')
write(11,'("#set label 1 ''c)'' at 6e7,0.05 center")')

write(11,'("plot [0:][0:1] ''cc=",a,"_ec=",a,"/rlink_glob_synch_average_C_matr_nnev12n",a,".dat'' u 2 w lp title ""r_{link}"", ''cc=",a,"_ec=",a,"/rlink_glob_synch_average_C_matr_nnev12n",a,".dat'' u 3 w lp title ""Order parameter r"", ''cc=",a,"_ec=",a,"/rlink_glob_synch_average_C_matr_nnev12n",a,".dat'' u 4 w lp title ""<C_{i,j}>""")') char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_param_chem_coupling,char_param_elec_coupling,char_num_neurons

close(11)

return
end subroutine create_plot_rlink_glob_synch_average_C_matr_gnu_file

!------------------------------------------------------------

subroutine create_plot_total_adjacency_matrix_gnu_file(char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization)
implicit none
character*(*),intent(in)	:: char_param_chem_coupling,char_param_elec_coupling,char_num_neurons,char_counter_realization

open(11,file='cc='//char_param_chem_coupling//'_ec='//char_param_elec_coupling//"/"//char_counter_realization//"rn/"//'plot_total_adjacency_matrix_nnev12n'//char_num_neurons//'.gnu',status='replace')
write(11,'("set output ''cc=",a,"_ec=",a,"/",a,"rn/total_adjacency_matrix_nnev12n",a,".eps''")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(11,'("set term postscript eps color enhanced")')
write(11,'("set size 0.6,0.6")')

write(11,'("#set pm3d map interpolate 0,0")')

write(11,'("set size square")')
write(11,'("unset key")')

write(11,'("set border linewidth 0")')

write(11,'("set title ''Adjacency matrix (structural connections)'' font "",9""")')

write(11,'("set cbtics 0.2")')
write(11,'("set cbrange [0:1]")')

write(11,'("rows = ""`awk ''END {print NR}'' < ''cc=",a,"_ec=",a,"/",a,"rn/total_adjacency_matrix_nnev12n",a,".dat''`""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(11,'("columns = ""`awk ''{if(NR == 1) print NF}'' < ''cc=",a,"_ec=",a,"/",a,"rn/total_adjacency_matrix_nnev12n",a,".dat''`""")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

write(11,'("set xtics (""1"" 0, gprintf(""%3.0f"",columns) columns-1)")')
write(11,'("set xtics add 0,columns/5,columns")')

write(11,'("set ytics (""1"" 0, gprintf(""%3.0f"",rows) rows-1)")')
write(11,'("set ytics add 0,rows/5,rows")')

write(11,'("#set xlabel ""Neuron""")')
write(11,'("#set ylabel ""Neuron"" rotate by 0 left")')
 
write(11,'("#splot [0:rows-1][columns-1:0] ''cc=",a,"_ec=",a,"/",a,"rn/total_adjacency_matrix_nnev12n",a,".dat'' matrix")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons
write(11,'("plot [-0.5:rows-0.5][columns-0.5:-0.5] ''cc=",a,"_ec=",a,"/",a,"rn/total_adjacency_matrix_nnev12n",a,".dat'' matrix with image")') char_param_chem_coupling,char_param_elec_coupling,char_counter_realization,char_num_neurons

close(11)

return
end subroutine create_plot_total_adjacency_matrix_gnu_file

!------------------------------------------------------------

subroutine initialize_random_number_seed(seed_ci_initial)
implicit none
integer(kind=4),intent(out)	:: seed_ci_initial
integer(kind=4),allocatable	:: newseed(:)
integer(kind=4)			:: dates(8),seed_size
character(10)			:: date,time

!to use random_seed,first determine the random seed's array size since this may be different for each compiler
call random_seed(size=seed_size) !determine seed array size
allocate(newseed(seed_size)) !allocate the seed array
!note: seed_size is 4 for G95, 1 for LF95, and 2 for Intel ifort

!user supplied new seed or generate a new seed as a "random" event of current date information
call date_and_time(date,time,values=dates)
!user supplied new seed
newseed=2013
!generate a new seed as a "random" event of current date information
!newseed=dates(1)+dates(2)+dates(3)+dates(5)+dates(6)+dates(7)+dates(8)

!write(*,*) 'newseed=',newseed,' is of size=',seed_size
call random_seed(put=newseed) !set random_number with the new seed

seed_ci_initial=newseed(1)

deallocate(newseed)

return
end subroutine initialize_random_number_seed
!------------------------------------------------------------
