filename='c-elegans_277'


set output 'mean_clustering_coefficient_of_nodes_with_degree_d_'.filename.'.eps'
set term postscript eps color enhanced font ",17"

set size 0.6,0.6


FIT_LIMIT = 1e-6
FIT_MAXITER = 0
!rm -rf fit.log
!rm -rf 'screen_output.out'

f(x) = a*exp(b*x) # define the function to be fitted
a = 0.1021	;	b = -0.0053654 # initial guess for a and b
fit [][] f(x) 'mean_clustering_coefficient_of_nodes_with_degree_d_'.filename.'.txt' using 1:2 via a, b
FIT_WSSR1=FIT_WSSR




#set format x "10^{%L}"
set format y "10^{%L}"

set style line 1 lt 7 lw 4 linecolor rgb "black"
set style line 2 lt 5 lw 4 linecolor rgb "grey"
set style line 3 lt 1 lw 4 linecolor rgb "black"

set label 1 "a)" at graph 0.92, 0.93

set logscale y

set xtics add ("0" 0)

set xlabel 'k_i'
set ylabel 'CC(k_i)'

set key at graph 0.93, graph 0.95

plot [0:][] 'mean_clustering_coefficient_of_nodes_with_degree_d_'.filename.'.txt' u 1:2 ls 3 w l notitle, f(x) ls 2 w l title sprintf("%4.2fe^{%4.2fk_i}",a,b)
